import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.Set;
import java.util.HashSet;

/** In-class lab for learning about hash code functions and collisions.

    @author arafferty
    @author Jed Yang
    @author YOUR NAME HERE
*/
public class HashCodes
{
   /** Always returns 0.  */
   public static int hashCode0(String s)
   {
      return 0;
   }

   /** Read through the code and change this comment to what this hash code
       function does. Note that casting a character to an integer returns its
       Unicode value: likely a number between 0 and 127.
   */
   public static int hashCode1(String s)
   {
      if (s.isEmpty())
      {
         return 0;
      }
      else
      {
         return (int)s.charAt(0);
      }
   }

   /** Read through the code and change this comment to what this hash code
       function does.
   */
   public static int hashCode2(String s)
   {
      int hashCode = 0;
      for (int i = 0; i < s.length(); i++)
      {
         hashCode += (int)s.charAt(i);
      }
      return hashCode;
   }

   /** Read through the code and change this comment to what this hash code
       function does. Hint: You might think about how you would write an
       integer as a sum that uses its digits to get a better understanding of
       what's happening here.
   */
   public static int hashCode3(String s)
   {
      int hashCode = 0;
      for (int i = 0; i < s.length(); i++)
      {
         hashCode = 128*hashCode + (int)s.charAt(i);
      }
      return hashCode;
   }

   /** Compression function that takes a hash code (positive or negative) and
       the number of buckets we have to use in our hash table, and compresses
       the hash code into the range [0, numberOfBuckets).
   */
   public static int compressToSize(int hashCode, int numberOfBuckets)
   {
      int compressedValue = hashCode % numberOfBuckets;
      // (Stupid Java!) Mod of a negative number is in range (-n, 0].  Map back
      // to positive so in the range of [0, numberOfBuckets)
      if (compressedValue < 0)
      {
         compressedValue += numberOfBuckets;
      }
      return compressedValue;
   }

   /** Counts the number of buckets that have no words stored in them (i.e.,
       they have value 0) and calculates what proportion of the total buckets
       that is.

       Hint: multiply an int by 1.0 to turn it into a double.
   */
   public static double getProportionOfEmptyBuckets(int[] buckets)
   {
      return -1;
   }

   /** Returns the size of the bucket with the most words.  */
   public static int getMaxBucketValue(int[] buckets)
   {
      return -1;
   }

   /** Returns the average number of words in each non-empty bucket */
   public static double getAverageInNonEmptyBuckets(int[] buckets)
   {
      return -1;
   }

   /** Implement this method so that it calculates how many words would be
       placed in each bucket in the array.  Each individual word should be
       counted only once (i.e., if "the" occurs 501 times in the file, you
       should only hash it once, rather than thinking of it as causing 500
       collisions).

       @param numBuckets number of slots to include in the array
       @param fileName file to read from
       @param hashCodeFunctionToUse which of the hash code functions to use
       @return an array that indicates how many different words are placed at
       index 0, 1, etc.
   */
   public static int[] collisionCounter(int numBuckets, String fileName,
                                        int hashCodeFunctionToUse)
   {
      // FIXME: Initialize the variables you'll need to count collisions (an
      // array, a Set)

      Scanner scanner = null;
      try
      {
         scanner = new Scanner(new File(fileName));
      }
      catch (FileNotFoundException e)
      {
         System.err.println("File not found: " + fileName);
         return null;
      }

      // FIXME: Write your code for counting collisions here.

      scanner.close();
      return null; // FIXME: Return your count of collisions
   }

   public static void main(String[] args)
   {

   }
}
